﻿using System.Data;
using System.Collections.Generic;
using System.Linq;

using Dapper;

namespace TestProject
{
    /// <summary>
    /// 주문 상세
    /// </summary>
    public class OrderDetail
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 주문 ID - OrderID

        /// <summary>
        /// 주문 ID
        /// </summary>
        public int? OrderID { get; set; }

        #endregion
        #region 상품 ID - ProductID

        /// <summary>
        /// 상품 ID
        /// </summary>
        public int ProductID { get; set; }

        #endregion
        #region 단가 - UnitPrice

        /// <summary>
        /// 단가
        /// </summary>
        public decimal UnitPrice { get; set; }

        #endregion
        #region 수량 - Quantity

        /// <summary>
        /// 수량
        /// </summary>
        public int Quantity { get; set; }

        #endregion
        #region 할인율 - Discount

        /// <summary>
        /// 할인율
        /// </summary>
        public float Discount { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 주문 상세 리스트 구하기 - GetOrderDetailList(connection)

        /// <summary>
        /// 주문 상세 리스트 구하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <returns>주문 상세 리스트</returns>
        public static List<OrderDetail> GetOrderDetailList(IDbConnection connection)
        {
            var resultList = connection.Query<OrderDetail>("SELECT * FROM [Order Details]").ToList();

            return resultList;
        }

        #endregion
        #region 주문 상세 리스트 구하기 - GetOrderDetailList(connection, order)

        /// <summary>
        /// 주문 상세 리스트 구하기
        /// </summary>
        /// <param name="connection">연결</param>
        /// <param name="order">주문</param>
        /// <returns>주문 상세 리스트</returns>
        public static List<OrderDetail> GetOrderDetailList(IDbConnection connection, Order order)
        {
            var resultList = connection.Query<OrderDetail>
            (
                "SELECT * FROM [Order Details] WHERE OrderID = @OrderID ORDER BY ProductID ASC",
                order
            ).ToList();

            return resultList;
        }

        #endregion
    }
}